<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Document</title>
	<style type="text/css" media="screen">
		.punto {
			background-color: black;
			position: absolute;
			left: 0px;
			top: 0px;
			width: 1px;
			height: 1px;
		}	

	</style>
	<script type="text/javascript">
		/**
		 * clase
		 */
		let Cuadrado=function(id,i,d, ancho=10, alto=10){
			// propiedades privadas
			let izquierda;
			let arriba;
			let atributoId;

			// propiedades publicas
			// mejor inicializarlas porque si no, no la crea
			this.ancho=10;
			this.alto=10;

			// constructor: metodo publico
			this.Cuadrado=function(id,i,d, ancho=10, alto=10){ //ancho=10, alto=10 es opcional porque ya está en la creación de la clase
				// inicializar los miembros
				izquierda=i;
				arriba=d;
				this.ancho=ancho;
				this.alto=alto;
				atributoId=id;

				// pintamos una caja en el body
				document.querySelector("body").innerHTML+='<div class="punto" id="'+ atributoId +'">&nbsp;</div>';
				document.querySelector("#"+atributoId).style.top=this.getArriba();
				document.querySelector("#"+atributoId).style.left=this.getIzquierda();
				document.querySelector("#"+atributoId).style.width=this.ancho + "px";
				document.querySelector("#"+atributoId).style.height=this.alto + "px";


			};

			// !IMPORTANTE
			// el constructor tiene que llamarse a sí mismo 
			// y pasarle los argumentos
			this.Cuadrado(id,i,d, ancho, alto);

			// elemento estático de tipo propiedad
			// miembro inventado
			Cuadrado.unidades="px";


			/**
			 * getter y setter
			 */
			this.setIzquierda=function(valor){
				izquierda=valor;
			}

			this.setArriba=function(valor){
				arriba=valor;
			}

			this.getIzquierda=function(){
				return izquierda+Cuadrado.unidades;
			}

			this.getArriba=function(){
				return arriba+Cuadrado.unidades;
			}
		}


		window.addEventListener("load", (e)=>{
			let uno=new Cuadrado("caja1",10,2);
			let dos = new Cuadrado("caja2",10,20);
			//console.log(uno.getArriba());
			//console.log(uno);		
			//console.log(dos.getArriba());
			//Cuadrado.unidades="pt";
			//console.log(uno.getArriba());
			//console.log(dos.getArriba());

		});


		/**
		 * Crear objeto
		 */
		
		
		
	</script>
</head>
<body>
	
</body>
</html>